Index: /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs	(revision 6839)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs	(revision 6840)
@@ -440,253 +516,295 @@
     partial void OnProcessorTypeChanging(string value);
     partial void OnProcessorTypeChanged();
+    partial void OnClientTypeIdChanging(System.Guid value);
+    partial void OnClientTypeIdChanged();
+    partial void OnOperatingSystemIdChanging(System.Guid value);
+    partial void OnOperatingSystemIdChanged();
+    partial void OnClientConfigurationIdChanging(System.Guid value);
+    partial void OnClientConfigurationIdChanged();
+    partial void OnCountryIdChanging(System.Guid value);
+    partial void OnCountryIdChanged();
     #endregion
-
-    public Client() {
-      this._ClientTypes = default(EntityRef<ClientType>);
-      this._OperatingSystems = default(EntityRef<OperatingSystem>);
-      this._Countries = default(EntityRef<Country>);
-      this._ClientConfiguration = default(EntityRef<ClientConfiguration>);
-      OnCreated();
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Name = "ClientConfiguration", Storage = "_ClientConfigurationId", DbType = "UniqueIdentifier")]
-    public System.Guid ClientConfigurationId {
-      get {
-        return this._ClientConfigurationId;
-      }
-      set {
-        if ((this._ClientConfigurationId != value)) {
-          this.OnClientConfigurationIdChanging(value);
-          this.SendPropertyChanging();
-          this._ClientConfigurationId = value;
-          this.SendPropertyChanged("ClientConfigurationId");
-          this.OnClientConfigurationIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Name = "ClientType", Storage = "_ClientType", DbType = "UniqueIdentifier")]
-    public System.Guid ClientTypeId {
-      get {
-        return this._ClientType;
-      }
-      set {
-        if ((this._ClientType != value)) {
-          this.OnClientTypeIdChanging(value);
-          this.SendPropertyChanging();
-          this._ClientType = value;
-          this.SendPropertyChanged("ClientTypeId");
-          this.OnClientTypeIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_HeuristicLabVersion", DbType = "NVarChar(MAX)", CanBeNull = false)]
-    public string HeuristicLabVersion {
-      get {
-        return this._HeuristicLabVersion;
-      }
-      set {
-        if ((this._HeuristicLabVersion != value)) {
-          this.OnHeuristicLabVersionChanging(value);
-          this.SendPropertyChanging();
-          this._HeuristicLabVersion = value;
-          this.SendPropertyChanged("HeuristicLabVersion");
-          this.OnHeuristicLabVersionChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Name = "Country", Storage = "_Country", DbType = "UniqueIdentifier")]
-    public System.Guid CountryId {
-      get {
-        return this._Country;
-      }
-      set {
-        if ((this._Country != value)) {
-          this.OnCountryIdChanging(value);
-          this.SendPropertyChanging();
-          this._Country = value;
-          this.SendPropertyChanged("CountryId");
-          this.OnCountryIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Name = "OperatingSystem", Storage = "_OperatingSystem", DbType = "UniqueIdentifier")]
-    public System.Guid OperatingSystemId {
-      get {
-        return this._OperatingSystem;
-      }
-      set {
-        if ((this._OperatingSystem != value)) {
-          this.OnOperatingSystemIdChanging(value);
-          this.SendPropertyChanging();
-          this._OperatingSystem = value;
-          this.SendPropertyChanged("OperatingSystemId");
-          this.OnOperatingSystemIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_MemorySize", DbType = "Int")]
-    public System.Nullable<int> MemorySize {
-      get {
-        return this._MemorySize;
-      }
-      set {
-        if ((this._MemorySize != value)) {
-          this.OnMemorySizeChanging(value);
-          this.SendPropertyChanging();
-          this._MemorySize = value;
-          this.SendPropertyChanged("MemorySize");
-          this.OnMemorySizeChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Timestamp", DbType = "DateTime")]
-    public System.Nullable<System.DateTime> Timestamp {
-      get {
-        return this._Timestamp;
-      }
-      set {
-        if ((this._Timestamp != value)) {
-          this.OnTimestampChanging(value);
-          this.SendPropertyChanging();
-          this._Timestamp = value;
-          this.SendPropertyChanged("Timestamp");
-          this.OnTimestampChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_NumberOfCores", DbType = "Int")]
-    public System.Nullable<int> NumberOfCores {
-      get {
-        return this._NumberOfCores;
-      }
-      set {
-        if ((this._NumberOfCores != value)) {
-          this.OnNumberOfCoresChanging(value);
-          this.SendPropertyChanging();
-          this._NumberOfCores = value;
-          this.SendPropertyChanged("NumberOfCores");
-          this.OnNumberOfCoresChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_ProcessorType", DbType = "NVarChar(MAX)")]
-    public string ProcessorType {
-      get {
-        return this._ProcessorType;
-      }
-      set {
-        if ((this._ProcessorType != value)) {
-          this.OnProcessorTypeChanging(value);
-          this.SendPropertyChanging();
-          this._ProcessorType = value;
-          this.SendPropertyChanged("ProcessorType");
-          this.OnProcessorTypeChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Client_ClientType", Storage = "_ClientTypes", ThisKey = "ClientTypeId", OtherKey = "Id", IsUnique = true, IsForeignKey = false)]
-    public ClientType ClientType {
-      get {
-        return this._ClientTypes.Entity;
-      }
-      set {
-        ClientType previousValue = this._ClientTypes.Entity;
-        if (((previousValue != value)
-              || (this._ClientTypes.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._ClientTypes.Entity = null;
-            previousValue.Client = null;
-          }
-          this._ClientTypes.Entity = value;
-          if ((value != null)) {
-            value.Client = this;
-          }
-          this.SendPropertyChanged("ClientType");
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Client_OperatingSystem", Storage = "_OperatingSystems", ThisKey = "OperatingSystemId", OtherKey = "Id", IsUnique = true, IsForeignKey = false)]
-    public OperatingSystem OperatingSystem {
-      get {
-        return this._OperatingSystems.Entity;
-      }
-      set {
-        OperatingSystem previousValue = this._OperatingSystems.Entity;
-        if (((previousValue != value)
-              || (this._OperatingSystems.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._OperatingSystems.Entity = null;
-            previousValue.Client = null;
-          }
-          this._OperatingSystems.Entity = value;
-          if ((value != null)) {
-            value.Client = this;
-          }
-          this.SendPropertyChanged("OperatingSystem");
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Client_Country", Storage = "_Countries", ThisKey = "CountryId", OtherKey = "Id", IsUnique = true, IsForeignKey = false)]
-    public Country Country {
-      get {
-        return this._Countries.Entity;
-      }
-      set {
-        Country previousValue = this._Countries.Entity;
-        if (((previousValue != value)
-              || (this._Countries.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._Countries.Entity = null;
-            previousValue.Client = null;
-          }
-          this._Countries.Entity = value;
-          if ((value != null)) {
-            value.Client = this;
-          }
-          this.SendPropertyChanged("Country");
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Client_ClientConfiguration", Storage = "_ClientConfiguration", ThisKey = "ClientConfigurationId", OtherKey = "Id", IsUnique = true, IsForeignKey = false)]
-    public ClientConfiguration ClientConfiguration {
-      get {
-        return this._ClientConfiguration.Entity;
-      }
-      set {
-        ClientConfiguration previousValue = this._ClientConfiguration.Entity;
-        if (((previousValue != value)
-              || (this._ClientConfiguration.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._ClientConfiguration.Entity = null;
-            previousValue.Client = null;
-          }
-          this._ClientConfiguration.Entity = value;
-          if ((value != null)) {
-            value.Client = this;
-          }
-          this.SendPropertyChanged("ClientConfiguration");
-        }
-      }
-    }
-  }
-
-  public partial class ClientGroup : Resource {
-
+		
+		public Client()
+		{
+			this._ClientType = default(EntityRef<ClientType>);
+			this._OperatingSystem = default(EntityRef<OperatingSystem>);
+			this._Country = default(EntityRef<Country>);
+			this._ClientConfiguration = default(EntityRef<ClientConfiguration>);
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_HeuristicLabVersion", DbType="NVarChar(MAX)", CanBeNull=false)]
+		public string HeuristicLabVersion
+		{
+			get
+			{
+				return this._HeuristicLabVersion;
+			}
+			set
+			{
+				if ((this._HeuristicLabVersion != value))
+				{
+					this.OnHeuristicLabVersionChanging(value);
+					this.SendPropertyChanging();
+					this._HeuristicLabVersion = value;
+					this.SendPropertyChanged("HeuristicLabVersion");
+					this.OnHeuristicLabVersionChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_MemorySize", DbType="Int")]
+		public System.Nullable<int> MemorySize
+		{
+			get
+			{
+				return this._MemorySize;
+			}
+			set
+			{
+				if ((this._MemorySize != value))
+				{
+					this.OnMemorySizeChanging(value);
+					this.SendPropertyChanging();
+					this._MemorySize = value;
+					this.SendPropertyChanged("MemorySize");
+					this.OnMemorySizeChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Timestamp", DbType="DateTime")]
+		public System.Nullable<System.DateTime> Timestamp
+		{
+			get
+			{
+				return this._Timestamp;
+			}
+			set
+			{
+				if ((this._Timestamp != value))
+				{
+					this.OnTimestampChanging(value);
+					this.SendPropertyChanging();
+					this._Timestamp = value;
+					this.SendPropertyChanged("Timestamp");
+					this.OnTimestampChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NumberOfCores", DbType="Int")]
+		public System.Nullable<int> NumberOfCores
+		{
+			get
+			{
+				return this._NumberOfCores;
+			}
+			set
+			{
+				if ((this._NumberOfCores != value))
+				{
+					this.OnNumberOfCoresChanging(value);
+					this.SendPropertyChanging();
+					this._NumberOfCores = value;
+					this.SendPropertyChanged("NumberOfCores");
+					this.OnNumberOfCoresChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProcessorType", DbType="NVarChar(MAX)")]
+		public string ProcessorType
+		{
+			get
+			{
+				return this._ProcessorType;
+			}
+			set
+			{
+				if ((this._ProcessorType != value))
+				{
+					this.OnProcessorTypeChanging(value);
+					this.SendPropertyChanging();
+					this._ProcessorType = value;
+					this.SendPropertyChanged("ProcessorType");
+					this.OnProcessorTypeChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ClientTypeId", DbType="UniqueIdentifier")]
+		public System.Guid ClientTypeId
+		{
+			get
+			{
+				return this._ClientTypeId;
+			}
+			set
+			{
+				if ((this._ClientTypeId != value))
+				{
+					if (this._ClientType.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnClientTypeIdChanging(value);
+					this.SendPropertyChanging();
+					this._ClientTypeId = value;
+					this.SendPropertyChanged("ClientTypeId");
+					this.OnClientTypeIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_OperatingSystemId", DbType="UniqueIdentifier")]
+		public System.Guid OperatingSystemId
+		{
+			get
+			{
+				return this._OperatingSystemId;
+			}
+			set
+			{
+				if ((this._OperatingSystemId != value))
+				{
+					if (this._OperatingSystem.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnOperatingSystemIdChanging(value);
+					this.SendPropertyChanging();
+					this._OperatingSystemId = value;
+					this.SendPropertyChanged("OperatingSystemId");
+					this.OnOperatingSystemIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ClientConfigurationId", DbType="UniqueIdentifier")]
+		public System.Guid ClientConfigurationId
+		{
+			get
+			{
+				return this._ClientConfigurationId;
+			}
+			set
+			{
+				if ((this._ClientConfigurationId != value))
+				{
+					if (this._ClientConfiguration.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnClientConfigurationIdChanging(value);
+					this.SendPropertyChanging();
+					this._ClientConfigurationId = value;
+					this.SendPropertyChanged("ClientConfigurationId");
+					this.OnClientConfigurationIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CountryId", DbType="UniqueIdentifier")]
+		public System.Guid CountryId
+		{
+			get
+			{
+				return this._CountryId;
+			}
+			set
+			{
+				if ((this._CountryId != value))
+				{
+					if (this._Country.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnCountryIdChanging(value);
+					this.SendPropertyChanging();
+					this._CountryId = value;
+					this.SendPropertyChanged("CountryId");
+					this.OnCountryIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="ClientType_Client", Storage="_ClientType", ThisKey="ClientTypeId", OtherKey="Id", IsForeignKey=true)]
+		public ClientType ClientType
+		{
+			get
+			{
+				return this._ClientType.Entity;
+			}
+			set
+			{
+				if ((this._ClientType.Entity != value))
+				{
+					this.SendPropertyChanging();
+					this._ClientType.Entity = value;
+					this.SendPropertyChanged("ClientType");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="OperatingSystem_Client", Storage="_OperatingSystem", ThisKey="OperatingSystemId", OtherKey="Id", IsForeignKey=true)]
+		public OperatingSystem OperatingSystem
+		{
+			get
+			{
+				return this._OperatingSystem.Entity;
+			}
+			set
+			{
+				if ((this._OperatingSystem.Entity != value))
+				{
+					this.SendPropertyChanging();
+					this._OperatingSystem.Entity = value;
+					this.SendPropertyChanged("OperatingSystem");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Country_Client", Storage="_Country", ThisKey="CountryId", OtherKey="Id", IsForeignKey=true)]
+		public Country Country
+		{
+			get
+			{
+				return this._Country.Entity;
+			}
+			set
+			{
+				if ((this._Country.Entity != value))
+				{
+					this.SendPropertyChanging();
+					this._Country.Entity = value;
+					this.SendPropertyChanged("Country");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="ClientConfiguration_Client", Storage="_ClientConfiguration", ThisKey="ClientConfigurationId", OtherKey="Id", IsForeignKey=true)]
+		public ClientConfiguration ClientConfiguration
+		{
+			get
+			{
+				return this._ClientConfiguration.Entity;
+			}
+			set
+			{
+				if ((this._ClientConfiguration.Entity != value))
+				{
+					this.SendPropertyChanging();
+					this._ClientConfiguration.Entity = value;
+					this.SendPropertyChanged("ClientConfiguration");
+				}
+			}
+		}
+	}
+	
+	public partial class ClientGroup : Resource
+	{
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
@@ -694,23 +812,25 @@
     partial void OnCreated();
     #endregion
-
-    public ClientGroup() {
-      OnCreated();
-    }
-  }
-
-  [global::System.Data.Linq.Mapping.TableAttribute(Name = "dbo.ResourceResourceGroup")]
-  public partial class ResourceResourceGroup : INotifyPropertyChanging, INotifyPropertyChanged {
-
-    private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
-
-    private System.Guid _ResourceId;
-
-    private System.Guid _ResourceGroupId;
-
-    private EntityRef<Resource> _Resource;
-
-    private EntityRef<Resource> _Resource1;
-
+		
+		public ClientGroup()
+		{
+			OnCreated();
+		}
+	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.ResourceResourceGroup")]
+	public partial class ResourceResourceGroup : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.Guid _ResourceId;
+		
+		private System.Guid _ResourceGroupId;
+		
+		private EntityRef<Resource> _Resource;
+		
+		private EntityRef<Resource> _Resource1;
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
@@ -722,131 +842,163 @@
     partial void OnResourceGroupIdChanged();
     #endregion
-
-    public ResourceResourceGroup() {
-      this._Resource = default(EntityRef<Resource>);
-      this._Resource1 = default(EntityRef<Resource>);
-      OnCreated();
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_ResourceId", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
-    public System.Guid ResourceId {
-      get {
-        return this._ResourceId;
-      }
-      set {
-        if ((this._ResourceId != value)) {
-          if (this._Resource1.HasLoadedOrAssignedValue) {
-            throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-          }
-          this.OnResourceIdChanging(value);
-          this.SendPropertyChanging();
-          this._ResourceId = value;
-          this.SendPropertyChanged("ResourceId");
-          this.OnResourceIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_ResourceGroupId", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
-    public System.Guid ResourceGroupId {
-      get {
-        return this._ResourceGroupId;
-      }
-      set {
-        if ((this._ResourceGroupId != value)) {
-          if (this._Resource.HasLoadedOrAssignedValue) {
-            throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-          }
-          this.OnResourceGroupIdChanging(value);
-          this.SendPropertyChanging();
-          this._ResourceGroupId = value;
-          this.SendPropertyChanged("ResourceGroupId");
-          this.OnResourceGroupIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ResourceResourceGroup", Storage = "_Resource", ThisKey = "ResourceGroupId", OtherKey = "Id", IsForeignKey = true)]
-    public Resource ParentResource {
-      get {
-        return this._Resource.Entity;
-      }
-      set {
-        Resource previousValue = this._Resource.Entity;
-        if (((previousValue != value)
-              || (this._Resource.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._Resource.Entity = null;
-            previousValue.ResourceResourceGroupsChilds.Remove(this);
-          }
-          this._Resource.Entity = value;
-          if ((value != null)) {
-            value.ResourceResourceGroupsChilds.Add(this);
-            this._ResourceGroupId = value.Id;
-          } else {
-            this._ResourceGroupId = default(System.Guid);
-          }
-          this.SendPropertyChanged("ParentResource");
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ResourceResourceGroup1", Storage = "_Resource1", ThisKey = "ResourceId", OtherKey = "Id", IsForeignKey = true)]
-    public Resource Resource {
-      get {
-        return this._Resource1.Entity;
-      }
-      set {
-        Resource previousValue = this._Resource1.Entity;
-        if (((previousValue != value)
-              || (this._Resource1.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._Resource1.Entity = null;
-            previousValue.ResourceResourceGroupsParents.Remove(this);
-          }
-          this._Resource1.Entity = value;
-          if ((value != null)) {
-            value.ResourceResourceGroupsParents.Add(this);
-            this._ResourceId = value.Id;
-          } else {
-            this._ResourceId = default(System.Guid);
-          }
-          this.SendPropertyChanged("Resource");
-        }
-      }
-    }
-
-    public event PropertyChangingEventHandler PropertyChanging;
-
-    public event PropertyChangedEventHandler PropertyChanged;
-
-    protected virtual void SendPropertyChanging() {
-      if ((this.PropertyChanging != null)) {
-        this.PropertyChanging(this, emptyChangingEventArgs);
-      }
-    }
-
-    protected virtual void SendPropertyChanged(String propertyName) {
-      if ((this.PropertyChanged != null)) {
-        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
-      }
-    }
-  }
-
-  [global::System.Data.Linq.Mapping.TableAttribute(Name = "dbo.ClientLog")]
-  public partial class ClientLog : INotifyPropertyChanging, INotifyPropertyChanged {
-
-    private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
-
-    private System.DateTime _Timestamp;
-
-    private System.Guid _ResourceId;
-
-    private string _Message;
-
-    private EntityRef<Resource> _Resource;
-
+		
+		public ResourceResourceGroup()
+		{
+			this._Resource = default(EntityRef<Resource>);
+			this._Resource1 = default(EntityRef<Resource>);
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid ResourceId
+		{
+			get
+			{
+				return this._ResourceId;
+			}
+			set
+			{
+				if ((this._ResourceId != value))
+				{
+					if (this._Resource1.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnResourceIdChanging(value);
+					this.SendPropertyChanging();
+					this._ResourceId = value;
+					this.SendPropertyChanged("ResourceId");
+					this.OnResourceIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceGroupId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid ResourceGroupId
+		{
+			get
+			{
+				return this._ResourceGroupId;
+			}
+			set
+			{
+				if ((this._ResourceGroupId != value))
+				{
+					if (this._Resource.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnResourceGroupIdChanging(value);
+					this.SendPropertyChanging();
+					this._ResourceGroupId = value;
+					this.SendPropertyChanged("ResourceGroupId");
+					this.OnResourceGroupIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ResourceResourceGroup", Storage="_Resource", ThisKey="ResourceGroupId", OtherKey="Id", IsForeignKey=true)]
+		public Resource ParentResource
+		{
+			get
+			{
+				return this._Resource.Entity;
+			}
+			set
+			{
+				Resource previousValue = this._Resource.Entity;
+				if (((previousValue != value) 
+							|| (this._Resource.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._Resource.Entity = null;
+						previousValue.ResourceResourceGroupsChilds.Remove(this);
+					}
+					this._Resource.Entity = value;
+					if ((value != null))
+					{
+						value.ResourceResourceGroupsChilds.Add(this);
+						this._ResourceGroupId = value.Id;
+					}
+					else
+					{
+						this._ResourceGroupId = default(System.Guid);
+					}
+					this.SendPropertyChanged("ParentResource");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ResourceResourceGroup1", Storage="_Resource1", ThisKey="ResourceId", OtherKey="Id", IsForeignKey=true)]
+		public Resource Resource
+		{
+			get
+			{
+				return this._Resource1.Entity;
+			}
+			set
+			{
+				Resource previousValue = this._Resource1.Entity;
+				if (((previousValue != value) 
+							|| (this._Resource1.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._Resource1.Entity = null;
+						previousValue.ResourceResourceGroupsParents.Remove(this);
+					}
+					this._Resource1.Entity = value;
+					if ((value != null))
+					{
+						value.ResourceResourceGroupsParents.Add(this);
+						this._ResourceId = value.Id;
+					}
+					else
+					{
+						this._ResourceId = default(System.Guid);
+					}
+					this.SendPropertyChanged("Resource");
+				}
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.ClientLog")]
+	public partial class ClientLog : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.DateTime _Timestamp;
+		
+		private System.Guid _ResourceId;
+		
+		private string _Message;
+		
+		private EntityRef<Resource> _Resource;
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
